﻿using System;

namespace ConsoleApplication1
{
    partial class Program
    {
        [LoaderOptimization(LoaderOptimization.SingleDomain)]
        static void Main(string[] args)
        {
            ShowProcessInfo();
            
            new StrongDLL.Class1().DoMethod(); // "StrongDLL.Class1.DoMethod called" 문자열 출력 코드 포함
            new WeakDLL.Class1().DoMethod(); // "WeakDLL.Class1.DoMethod called" 문자열 출력 코드 포함

            // AppDomain에 로드된 어셈블리 목록 출력
            WeakDLL.Class1.DisplayAssemblies(AppDomain.CurrentDomain);

            Console.WriteLine();

            AppDomain appDomain = AppDomain.CreateDomain("TestAppDomain 1");
            appDomain.DoCallBack(
                () =>
                {
                    new StrongDLL.Class1().DoMethod(); // "StrongDLL.Class1.DoMethod called" 문자열 출력 코드 포함
                    new WeakDLL.Class1().DoMethod(); // "WeakDLL.Class1.DoMethod called" 문자열 출력 코드 포함

                    // AppDomain에 로드된 어셈블리 목록 출력
                    WeakDLL.Class1.DisplayAssemblies(AppDomain.CurrentDomain);
                }
            );

            Console.WriteLine("Press any key to exit...");
            Console.ReadLine();
        }
    }
}
